; This is a final version providing the best compatibility with actual DOS

      DOSSEG              ;assembler directives for .com linking, in particular
     .MODEL tiny          ;this means that the screen output is the program
     .286                 ;itself; see the respective macro CreateText
     .CODE
      ORG 100h

     INCLUDE mode13h.asm
     INCLUDE clearpal.asm
     INCLUDE text.asm
     INCLUDE colcycle.asm
     INCLUDE retrace.asm
     INCLUDE textmode.asm
     INCLUDE terminat.asm
     INCLUDE keyboard.asm

     NumColors   = 30h
     NumRows     = 19h
     NumColumns  = 28h
     PaletteStep = 08h
     SkipMode    = 01h
     KeyPort     = 60h

Main:
     Mode13h 00h          ;destroys ax

     ClearPalBios
     
     CreateText NumRows NumColumns PaletteStep SkipMode

     xor  ax, ax          ;contains the palette index to start with
MainLoop:                 ;color cycling loop starts here
     ColorCycle NumColors

     push ax
     WaitRetrace          ;destroys al, dx

     in   al, KeyPort     ;read keyboard,     
     dec  al              ;if escape (scancode 1) is pressed
     jz   Termination     ;then terminate

     pop  ax

     inc  ax              ;increment palette starting index
     jmp  MainLoop

Termination:

     ClearKeyBufferSmall  ;destroys ax, es, si, di
     Textmode             ;destroys ax
     TerminateClean

     END Main
